{

  Nahrada klasickeho MessageDialogu
  ---------------------------------
  ....akorat se zatim nepodporuje HelpContext nebo co to je ten posledni
      parametr.


}
unit My_MB;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ImgList;

type
  TfMB = class(TForm)
    lMsg: TLabel;
    pnButtons: TPanel;
    pnBMP: TPanel;
    ilBMP: TImageList;
    imBMP: TImage;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }

  end;

function MB (Msg, Capt: string;
             Typ: TMsgDlgType;
             Buttons: TMsgDlgButtons;
             DefButton: TMsgDlgBtn;
             HelpCtx: Longint): Word;
var
  fMB: TfMB;

implementation

{$R *.DFM}

{-------------------------------------------------------------------InitForm---}
procedure InitForm;
begin { InitForm }
  with fMB do begin
    Width := 550;
    Height := 300;
    with lMsg do begin
      Width := 450;
      Height := 1;
      Caption := '---------------------------------------------------------------------------------------------------------------------------------------------------------';
    end;

  end;
end;  { InitForm }

{-------------------------------------------------------------------------MB---}
function MB (Msg, Capt: string;
             Typ: TMsgDlgType;
             Buttons: TMsgDlgButtons;
             DefButton: TMsgDlgBtn;
             HelpCtx: Longint): Word;
var
  MsgW, MsgH,
  TotalW, TotalH,
  ButtonsW,
  i, L, Posun: integer;
  DefBtn: integer;

  BField : array [1..9] of TBitBtn;


  procedure CreateButton (Bt: TMsgDlgBtn; Ki: TBitBtnKind);
  begin
    Buttons := Buttons - [Bt];
    BField [i] := TBitBtn.Create (fMB.pnButtons as TComponent);
    with BField [i] do begin
      Top := 0;
      Left := L;
      Parent := fMB.pnButtons;
      Kind := Ki;
      L := L + Width + 5;
      case Bt of
        mbYes: Caption := '&Ano';
        mbNo: Caption := '&Ne';
        mbOK: Caption := '&OK';
        mbCancel: Caption := '&Zruit';
        mbHelp: Caption := 'Npov&da';
        mbAbort: Caption := '&Peruit';
        mbRetry: Caption := '&Znovu';
        mbIgnore: Caption := '&Ignorovat';
        mbAll: Caption := '&Vechny';
      end;
      Cancel := false;
      if (Bt = DefButton) then DefBtn := i;
    end;
  end;

begin { MB }
  InitForm;
  DefBtn := 1;
  
  with fMB do begin
    { Help kontext }
    HelpContext := HelpCtx;

    { Obrazek (ikonka) }
    imBMP.Picture := nil;
    if (Typ <> mtCustom) then
      ilBMP.GetBitmap (Ord (Typ), imBMP.Picture.Bitmap);

    { Caption }
    Caption := Capt;

    { Zpravicka }
    lMsg.Caption := Msg;

    { Vypocty velikosti }
    MsgW := lMsg.ClientRect.Right - lMsg.ClientRect.Left;
    MsgH := lMsg.ClientRect.Bottom - lMsg.ClientRect.Top;
    TotalW := MsgW + pnBMP.Width + 50;
    TotalH := MsgH + 20 + pnButtons.Height;
    if TotalH < (pnBMP.Height + pnButtons.Height) then
      TotalH := (pnBMP.Height + pnButtons.Height);

    L := 10;
    for i := 1 to 9 do
      BField [i] := nil;

    for i := 1 to 9 do begin
      if (mbHelp in Buttons) then begin
        CreateButton (mbHelp, bkHelp);
        continue;
      end;
      if (mbOK in Buttons) then begin
        CreateButton (mbOK, bkOK);
        continue;
      end;
      if (mbYes in Buttons) then begin
        CreateButton (mbYes, bkYes);
        continue;
      end;
      if (mbNO in Buttons) then begin
        CreateButton (mbNO, bkNO);
        continue;
      end;
      if (mbAbort in Buttons) then begin
        CreateButton (mbAbort, bkAbort);
        continue;
      end;
      if (mbRetry in Buttons) then begin
        CreateButton (mbRetry, bkRetry);
        continue;
      end;
      if (mbIgnore in Buttons) then begin
        CreateButton (mbIgnore, bkIgnore);
        continue;
      end;
      if (mbAll in Buttons) then begin
        CreateButton (mbAll, bkAll);
        continue;
      end;
      if (mbCancel in Buttons) then begin
        CreateButton (mbCancel, bkCancel);
        continue;
      end;
    end;

    { vetsi mezery na krajich }
    ButtonsW := L+5;
    ClientHeight := TotalH;

    ClientWidth := TotalW;
    if Width < ButtonsW + 10 then ClientWidth := ButtonsW + 10;

    { Zarovnani tlacitek }
    Posun := (ClientWidth - ButtonsW) div 2;
    for i := 1 to 9 do begin
      if (BField [i] <> nil) then
         (BField [i] as TBitBtn).Left := ((BField [i] as TBitBtn).Left + Posun);
    end;

    Left := (Screen.Width - Width) div 2;
    Top := (Screen.Height - Height) div 2;

    fMB.ActiveControl := BField[DefBtn];
    Result := fMB.ShowModal;

    for i := 1 to 9 do
      if (BField[i] <> nil) then BField[i].Free;
  end;
end; { MB }

procedure TfMB.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_ESCAPE) then begin
    ModalResult := mrCancel;
    Key := 0;
    Close;
  end;
end;

end.
